﻿@using System.Web.UI.WebControls;
@using Toyota.Common.Web.Html;
@using Toyota.Common.Web.MVC;
@using Toyota.Common.Web.Html.Helper;
@using DevExpress.Web;
@using DevExpress.Web.Mvc;

@model Toyota.Common.Web.MVC.ModelHolder
           
@{
    Layout = "~/Views/Layout/Dashboard.cshtml";
}

@*--- Created by : niit.yudha 24/10/2012  *@
@*--- Changed by : fid.salman 17-jan-2013 *@

<script src="@Url.Content("~/Scripts/jquery.mtz.monthpicker.js")" type="text/javascript"></script>

@section Style{
    .ui-datepicker.ui-corner-all { -moz-border-radius: 4px; -webkit-border-radius: 4px; border-radius: 4px; }
    .iu-widget-header { background-color: #94B6E8; color: #94B6E8; }
    .ui-widget-header {
        background: url("images/ui-bg_highlight-soft_15_cc0000_1x100.png") repeat-x scroll 50% 50% #94B6E8;
        background-color: #DDECFF;
        border: 1px solid #94B6E8;
        color: #94B6E8;
        font-weight: bold;
    }
    div.ui-datepicker {width: 17em; padding: .2em .2em 0;}
    div.ui-datepicker-header.mtz-monthpicker {border: 1px solid #DDECFF; background-color: #DDECFF; color: #DDECFF; font-weight: bold;}
    table.mtz-monthpicker {width: 100%; font-size: .9em; border-collapse: collapse; margin:0 0 .4em; }
    td.ui-state-default.mtz-monthpicker-month {border: 1px solid #fff;}
    td.ui-state-default.mtz-monthpicker-month {text-align: center; cursor: pointer; padding: 5px;}
    td.ui-state-default.mtz-monthpicker-month:hover, td.ui-state-default.mtz-monthpicker-month-selected {background: none; background-color: #DDECFF; color: #fff; cursor: pointer;}
    td.ui-state-default.mtz-monthpicker-month:hover {background-color: #fff; color: #000;}
    select.mtz-monthpicker-year {margin-top: 7px;}
}

@section Script{
    $(document).ready(function() { 
        @*SFSDGridView.Refresh(); *@

        $('#SFSHProductionMonthText_I').monthpicker({
            startYear: new Date().getFullYear() - 5,
            finalYear: new Date().getFullYear() + 1,
            pattern: 'mmm yyyy', 
            monthNames: ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December']
        });

        $('#SFSHProductionMonthText_I').bind('onchange',function(e){
            alert("input change");
        });        
        
        Date.isLeapYear = function (year) {
            return (((year % 4 === 0) && (year % 100 !== 0)) || (year % 400 === 0));
        };

        Date.getDaysInMonth = function (year, month) {
            return [31, (Date.isLeapYear(year) ? 29 : 28), 31, 30, 31, 30, 31, 31, 30, 31, 30, 31][month];
        };

        Date.prototype.isLeapYear = function () {
            return Date.isLeapYear(this.getFullYear());
        };

        Date.prototype.getDaysInMonth = function () {
            return Date.getDaysInMonth(this.getFullYear(), this.getMonth());
        };

        Date.prototype.addMonths = function (value) {
            var n = this.getDate();
            this.setDate(1);
            this.setMonth(this.getMonth() + value);
            this.setDate(Math.min(n, this.getDaysInMonth()));
            return this;
        };

        @*var today = new Date();        
        productionMonth = isNaN(getParameterByName("ProductionMonth")) ? (today.getFullYear() + pad(today.getMonth() + 1)) : getParameterByName("ProductionMonth");
        SFSHProductionMonthText_I.value = GetRegularProductionMonth(productionMonth);*@
    }); 
}

<script type="text/javascript">
    // =========================== Parameter variabels =============================
    var productionMonth = "";
    var supplierCode = "";
    var supplierPlantCode = "";
    var timing = "";

    //Added by Fid.Reggy
    var version = "";
    var filePath = "";
    // =============================================================================

    // ============================ general function ==============================
    function getParameterByName(name) {
        name = name.replace(/[\[]/, "\\\[").replace(/[\]]/, "\\\]");
        var regexS = "[\\?&]" + name + "=([^&#]*)";
        var regex = new RegExp(regexS);
        var results = regex.exec(window.location.search);
        if (results == null)
            return "";
        else
            return decodeURIComponent(results[1].replace(/\+/g, " "));
    }

    function pad(n) {
        return (n < 10) && (n >= 0) ? ("0" + n) : n;
    }
    
    function GetProductionMonth(productionMonth) {
        var paramStr = String(productionMonth).replace(' ', '');
        var paramStrLength = String(paramStr).length;

        var year = String(paramStr).substring(paramStrLength, paramStrLength - 4);
        var month = String(paramStr).substring(0, paramStrLength - 4);
        var monthEnum = {
            January: '01',
            February: '02',
            March: '03',
            April: '04',
            May: '05',
            June: '06',
            July: '07',
            August: '08',
            September: '09',
            October: '10',
            November: '11',
            December: '12'
        };
        var monthNum = "";
        if (Boolean(month))
            monthNum = monthEnum[month];

        return year + monthNum;
    }

    function GetRegularProductionMonth(productionMonth) {
        var year = String(productionMonth).substring(0, 4);
        var month = String(productionMonth).substring(String(productionMonth).length, String(productionMonth).length - 2);
        var monthEnum = {
            '01': 'January',
            '02': 'February',
            '03': 'March',
            '04': 'April',
            '05': 'May',
            '06': 'June',
            '07': 'July',
            '08': 'August',
            '09': 'September',
            '10': 'October',
            '11': 'November',
            '12': 'December'
        };

        return monthEnum[month] + " " + year;
    }
    // =============================================================================

    // ================= supplier feedback summary header function =================
    function OnSFSHSupplierIDOptionButtonClick(s, e) {
        supplierCode = SFSHSupplierIDOption.GetValue();

        GridSFSHSupplierPlantCodeOption.PerformCallback();
    }

    function OnSFSHSupplierPlantCodeOptionBeginCallback(s, e) {
        e.customArgs["SupplierCode"] = supplierCode;
    }

    function OnSFSHDownloadButtonClick(s, e) {    
            $.fileDownload("SupplierFeedbackSummary/DownloadFeedbackSummary/", {
                data: {
                    productionMonth: GetProductionMonth(SFSHProductionMonthText_I.value),
                    supplierCode: SFSHSupplierIDOption.GetValue(),
                    supplierPlanCode: SFSHSupplierPlantCodeOption.GetValue(),
                    timing : SFSHTimingOption.GetValue()
                },
                successCallback: function (url) {
                },
                failCallback: function (responseHtml, url) {
                    alert(responseHtml);
                }
            });
    }

    function OnSFSHSearchButtonClick(s, e) {
        SFSDGridView.PerformCallback();
    }

    function OnSFSHClearButtonClick(s, e) {


        //var today = new Date();
        //SFSHProductionMonthText_I.value = GetRegularProductionMonth(today.getFullYear() + pad(today.getMonth() + 1));
        
        var today = new Date();
        productionMonth = today.getFullYear() + pad(today.getMonth() + 1).toString();
        SFSHProductionMonthText_I.value = GetRegularProductionMonth(productionMonth);

        SFSHSupplierIDOption.SetValue();
        GridSFSHSupplierIDOption.UnselectRows();

        SFSHSupplierPlantCodeOption.SetValue();
        GridSFSHSupplierPlantCodeOption.UnselectRows();

        SFSHTimingOption.SetValue();

        SFSDGridView.ClearFilter();

        SFSDGridView.PerformCallback();
    }

    function OnSFSHProductionMonthTextTextChanged(s, e) {
        SFSDGridView.PerformCallback();
    }
    // =============================================================================

    // ================= supplier feedback summary detail function =================
    // Changed By   : fid.salman
    // Changed Date : 28.08.2013
    // Description  : Prevent multiple callback from ASPxClientGridView with disabling trigger control.
    function OnSupplierFeedbackSummaryHeaderPartialButtonEnabled(isEnabled) {
        SFSHDownloadButton.SetEnabled(isEnabled);
        SFSHSearchButton.SetEnabled(isEnabled);
        SFSHClearButton.SetEnabled(isEnabled);
    }

    function OnSFSDGridViewInit(s, e) {
        OnSupplierFeedbackSummaryHeaderPartialButtonEnabled(true);
    }

    function OnSFSDGridViewBeginCallback(s, e) {
        OnSupplierFeedbackSummaryHeaderPartialButtonEnabled(false);

        e.customArgs["ProductionMonth"] = GetProductionMonth(SFSHProductionMonthText_I.value);
        e.customArgs["SupplierCode"] = SFSHSupplierIDOption.GetValue();
        e.customArgs["SupplierPlantCode"] = SFSHSupplierPlantCodeOption.GetValue();
        e.customArgs["Timing"] = SFSHTimingOption.GetValue();
    }

    function OnSFSDGridViewEndCallback(s, e) {
        OnSupplierFeedbackSummaryHeaderPartialButtonEnabled(true);
    }

    function OnSFSDGridViewRowClick(s, e) {
    }

    function OnSFSDUnlockImageClick(s, e) {
        var index = s.name.substring(15);

        index = index - (SFSDGridView.GetPageIndex() * SFSDGridView.cpPageSize);

        productionMonth = SFSDGridView.cpProductionMonth[index];
        supplierCode = SFSDGridView.cpSupplierCd[index];
        supplierPlantCode = SFSDGridView.cpSupplierPlant[index];
        timing = SFSDGridView.cpTiming[index];

        if (SFSDGridView.cpStatus[index])
            popupSupplierFeedbackSummaryDetailUnlockConfirmation.Show();
    }

    function OnSFSDFeedbackDataFileImageClick(s, e) {
        var index = s.name.substring(25);

        index = index - (SFSDGridView.GetPageIndex() * SFSDGridView.cpPageSize);

        $.fileDownload("SupplierFeedbackSummary/DownloadFeedbackPart/", {
            data: {
                productionMonth: SFSDGridView.cpProductionMonth[index],
                supplierCode: SFSDGridView.cpSupplierCd[index],
                supplierPlanCode: SFSDGridView.cpSupplierPlant[index],
                version: SFSDGridView.cpTiming[index]
            },
            successCallback: function (url) {
                
            },
            failCallback: function (responseHtml, url) {
                alert("Error On SFSDFeedbackDataFileImage Click.");
            }
        });
    }

    function OnSFSDFeedbackReplyLinkClick(s, e) {
        var index = s.name.substring(22);

        index = index - (SFSDGridView.GetPageIndex() * SFSDGridView.cpPageSize);

        productionMonth = SFSDGridView.cpProductionMonth[index];
        supplierCode = SFSDGridView.cpSupplierCd[index];
        supplierPlantCode = SFSDGridView.cpSupplierPlant[index];
        timing = SFSDGridView.cpTiming[index];

        popupFeedbackPart.Show();
    }
    // =============================================================================

    // ================ common feedback summary popup function =====================
    function OnPopupFeedbackBeginCallback(s, e) {
        e.customArgs["ProductionMonth"] = productionMonth;
        e.customArgs["SupplierCode"] = supplierCode;
        e.customArgs["SupplierPlanCode"] = supplierPlantCode;
        e.customArgs["Timing"] = timing;
        e.customArgs["Version"] = timing;
    }

    function OnPopupFeedbackClosing(s, e) {
        SFSDGridView.PerformCallback();
    }
    // =============================================================================

    // ================== supplier feedback summary popup function =================
    function OnPopupSupplierFeedbackSummaryDetailUnlockConfirmationShown(s, e) {
        $("#SFSDUCProductionMonthLabel").text(GetRegularProductionMonth(productionMonth));
        $("#SFSDUCSupplierLabel").text(supplierCode + (supplierPlantCode == false ? '' : ('-' + supplierPlantCode)));
        $("#SFSDUCTimingLabel").text(timing == 'T' ? 'Tentative' : 'Firm');
    }

    function OnSFSDUCOkButtonClick(s, e) {
        $.ajax({
            type: "POST",
            url: "@Url.Content("~/Forecast/UnlockForecast")",
            data: {
                productionMonth: GetProductionMonth($("#SFSDUCProductionMonthLabel").text()),
                supplierCode: $("#SFSDUCSupplierLabel").text().split('-')[0],
                version: $("#SFSDUCTimingLabel").text().substring(0, 1),
                supplierPlanCode: $("#SFSDUCSupplierLabel").text().split('-')[1]
            },
            success: function (result) {
                popupSupplierFeedbackSummaryDetailUnlockConfirmation.Hide();
            },
            error: function (result) {
                alert("Error On SFSDUCOkButton Click.");
            }
        });
    }

    function OnSFSDUCCancelButtonClick(s, e) {
        popupSupplierFeedbackSummaryDetailUnlockConfirmation.Hide();
    }
    // =============================================================================

    // =================== forecast feedback part function =========================

    // handle row seleciton with overal capability drop down list.

    function OnSFPRHFOverallCapabilityOptionSelectedIndexChanged(fieldName, fieldValue) {
        // get previous stored radio button list sellection list.
        var previousSelectionList = [];
        previousSelectionList = SFPGFSupplierFeedbackPartViewSelectionLabel.GetValue().split(';');
        if (previousSelectionList[0] != null && previousSelectionList[0] != '')
            SFPGFSupplierFeedbackPartView.cpNReply = previousSelectionList[0].split(',');
        if (previousSelectionList[1] != null && previousSelectionList[1] != '')
            SFPGFSupplierFeedbackPartView.cpN1Reply = previousSelectionList[1].split(',');
        if (previousSelectionList[2] != null && previousSelectionList[2] != '')
            SFPGFSupplierFeedbackPartView.cpN2Reply = previousSelectionList[2].split(',');
        if (previousSelectionList[3] != null && previousSelectionList[3] != '')
            SFPGFSupplierFeedbackPartView.cpN3Reply = previousSelectionList[3].split(',');

        for (var index = SFPGFSupplierFeedbackPartView.cpStartIndex; index < SFPGFSupplierFeedbackPartView.cpEndIndex; index++) {
            switch (fieldName) {
                case 'N_MONTH':
                    if (index >= SFPGFSupplierFeedbackPartView.GetTopVisibleIndex() &&
                        index < SFPGFSupplierFeedbackPartView.GetVisibleRowsOnPage() + (SFPGFSupplierFeedbackPartView.GetPageIndex() * SFPGFSupplierFeedbackPartView.cpPageSize)) {
                        var radioButtonList = ASPxClientControl.GetControlCollection().GetByName("SFPGFGRPN_REPLY" + index);
                        if (radioButtonList != null) {
                            // this block code (set radio button list selected index) only occur for showed page. not
                            // other page index of gridview
                            radioButtonList.SetSelectedIndex(fieldValue);
                        }
                    }

                    SFPGFSupplierFeedbackPartView.cpNReply[index] = fieldValue;
                    break;
                case 'N_1_MONTH':
                    if (index >= SFPGFSupplierFeedbackPartView.GetTopVisibleIndex() &&
                        index < SFPGFSupplierFeedbackPartView.GetVisibleRowsOnPage() + (SFPGFSupplierFeedbackPartView.GetPageIndex() * SFPGFSupplierFeedbackPartView.cpPageSize)) {
                        var radioButtonList = ASPxClientControl.GetControlCollection().GetByName("SFPGFGRPN_1_REPLY" + index);
                        if (radioButtonList != null) {
                            // this block code (set radio button list selected index) only occur for showed page. not
                            // other page index of gridview
                            radioButtonList.SetSelectedIndex(fieldValue);
                        }
                    }

                    SFPGFSupplierFeedbackPartView.cpN1Reply[index] = fieldValue;
                    break;
                case 'N_2_MONTH':
                    if (index >= SFPGFSupplierFeedbackPartView.GetTopVisibleIndex() &&
                        index < SFPGFSupplierFeedbackPartView.GetVisibleRowsOnPage() + (SFPGFSupplierFeedbackPartView.GetPageIndex() * SFPGFSupplierFeedbackPartView.cpPageSize)) {
                        var radioButtonList = ASPxClientControl.GetControlCollection().GetByName("SFPGFGRPN_2_REPLY" + index);
                        if (radioButtonList != null) {
                            // this block code (set radio button list selected index) only occur for showed page. not
                            // other page index of gridview
                            radioButtonList.SetSelectedIndex(fieldValue);
                        }
                    }

                    SFPGFSupplierFeedbackPartView.cpN2Reply[index] = fieldValue;
                    break;
                case 'N_3_MONTH':
                    if (index >= SFPGFSupplierFeedbackPartView.GetTopVisibleIndex() &&
                        index < SFPGFSupplierFeedbackPartView.GetVisibleRowsOnPage() + (SFPGFSupplierFeedbackPartView.GetPageIndex() * SFPGFSupplierFeedbackPartView.cpPageSize)) {
                        var radioButtonList = ASPxClientControl.GetControlCollection().GetByName("SFPGFGRPN_3_REPLY" + index);
                        if (radioButtonList != null) {
                            // this block code (set radio button list selected index) only occur for showed page. not
                            // other page index of gridview
                            radioButtonList.SetSelectedIndex(fieldValue);
                        }
                    }

                    SFPGFSupplierFeedbackPartView.cpN3Reply[index] = fieldValue;
                    break;
            }
        }

        var selectionList = [];
        selectionList[0] = SFPGFSupplierFeedbackPartView.cpNReply.join(',');
        selectionList[1] = SFPGFSupplierFeedbackPartView.cpN1Reply.join(',');
        selectionList[2] = SFPGFSupplierFeedbackPartView.cpN2Reply.join(',');
        selectionList[3] = SFPGFSupplierFeedbackPartView.cpN3Reply.join(',');

        SFPGFSupplierFeedbackPartViewSelectionLabel.SetValue(selectionList.join(';'));
    }

    function OnSFPRHFNMonthOptionSelectedIndexChanged(s, e) {
        OnSFPRHFOverallCapabilityOptionSelectedIndexChanged('N_MONTH', SFPRHFNMonthOption.GetSelectedIndex());
    }

    function OnSFPRHFN1MonthOptionSelectedIndexChanged(s, e) {
        OnSFPRHFOverallCapabilityOptionSelectedIndexChanged('N_1_MONTH', SFPRHFN1MonthOption.GetSelectedIndex());
    }

    function OnSFPRHFN2MonthOptionSelectedIndexChanged(s, e) {
        OnSFPRHFOverallCapabilityOptionSelectedIndexChanged('N_2_MONTH', SFPRHFN2MonthOption.GetSelectedIndex());
    }

    function OnSFPRHFN3MonthOptionSelectedIndexChanged(s, e) {
        OnSFPRHFOverallCapabilityOptionSelectedIndexChanged('N_3_MONTH', SFPRHFN3MonthOption.GetSelectedIndex());
    }

    function OnSFPRHFCancelButtonClick(s, e) {
        SFPRHFNMonthOption.SetValue();
        SFPRHFN1MonthOption.SetValue();
        SFPRHFN2MonthOption.SetValue();
        SFPRHFN3MonthOption.SetValue();

        SFPGFSupplierFeedbackPartViewSelectionLabel.SetValue();

        var previousSelectionList = [];
        previousSelectionList = SFPGFSupplierFeedbackPartViewSelectionLabel.GetValue().split(';');
        if (previousSelectionList[0] != null && previousSelectionList[0] != '')
            SFPGFSupplierFeedbackPartView.cpNReply = previousSelectionList[0].split(',');
        if (previousSelectionList[1] != null && previousSelectionList[1] != '')
            SFPGFSupplierFeedbackPartView.cpN1Reply = previousSelectionList[1].split(',');
        if (previousSelectionList[2] != null && previousSelectionList[2] != '')
            SFPGFSupplierFeedbackPartView.cpN2Reply = previousSelectionList[2].split(',');
        if (previousSelectionList[3] != null && previousSelectionList[3] != '')
            SFPGFSupplierFeedbackPartView.cpN3Reply = previousSelectionList[3].split(',');

        var radioButtonList = null;
        for (var index = SFPGFSupplierFeedbackPartView.cpStartIndex; index < SFPGFSupplierFeedbackPartView.cpEndIndex; index++) {
            if (index >= SFPGFSupplierFeedbackPartView.GetTopVisibleIndex() &&
                        index < SFPGFSupplierFeedbackPartView.GetVisibleRowsOnPage() + (SFPGFSupplierFeedbackPartView.GetPageIndex() * SFPGFSupplierFeedbackPartView.cpPageSize)) {
                radioButtonList = ASPxClientControl.GetControlCollection().GetByName("SFPGFGRPN_REPLY" + index);
                if (radioButtonList != null) {
                    radioButtonList.SetSelectedIndex(-1);
                }
                SFPGFSupplierFeedbackPartView.cpNReply[index] = -1;

                radioButtonList = ASPxClientControl.GetControlCollection().GetByName("SFPGFGRPN_1_REPLY" + index);
                if (radioButtonList != null) {
                    radioButtonList.SetSelectedIndex(-1);
                }
                SFPGFSupplierFeedbackPartView.cpN1Reply[index] = -1;

                radioButtonList = ASPxClientControl.GetControlCollection().GetByName("SFPGFGRPN_2_REPLY" + index);
                if (radioButtonList != null) {
                    radioButtonList.SetSelectedIndex(-1);
                }
                SFPGFSupplierFeedbackPartView.cpN2Reply[index] = -1;

                radioButtonList = ASPxClientControl.GetControlCollection().GetByName("SFPGFGRPN_3_REPLY" + index);
                if (radioButtonList != null) {
                    radioButtonList.SetSelectedIndex(-1);
                }
                SFPGFSupplierFeedbackPartView.cpN3Reply[index] = -1;
            }
        }

        var selectionList = [];
        selectionList[0] = SFPGFSupplierFeedbackPartView.cpNReply.join(',');
        selectionList[1] = SFPGFSupplierFeedbackPartView.cpN1Reply.join(',');
        selectionList[2] = SFPGFSupplierFeedbackPartView.cpN2Reply.join(',');
        selectionList[3] = SFPGFSupplierFeedbackPartView.cpN3Reply.join(',');

        SFPGFSupplierFeedbackPartViewSelectionLabel.SetValue(selectionList.join(';'));
    }

    // for updating radion button value inside grid view row.

    function OnSFPGFSupplierFeedbackPartViewUpdateRow(s, e) {
        var selectionList = [];
        selectionList = SFPGFSupplierFeedbackPartViewSelectionLabel.GetValue().split(';');

        var radioButtonList;
        var selection = [];

        //Added Checking by Fid.reggy
        if ((selectionList.length > 0) && (selectionList[0] !== "")) {
            for (var index = SFPGFSupplierFeedbackPartView.cpStartIndex; index < SFPGFSupplierFeedbackPartView.cpEndIndex; index++) {
                if (index >= (SFPGFSupplierFeedbackPartView.GetPageIndex() * SFPGFSupplierFeedbackPartView.cpPageSize) &&
                    index < SFPGFSupplierFeedbackPartView.GetVisibleRowsOnPage() + (SFPGFSupplierFeedbackPartView.GetPageIndex() * SFPGFSupplierFeedbackPartView.cpPageSize)) {
                    selection = selectionList[0].split(',');

                    if (selection[index] != null && selection[index] != '') {
                        radioButtonList = ASPxClientControl.GetControlCollection().GetByName("SFPGFGRPN_REPLY" + index);
                        radioButtonList.SetSelectedIndex(selection[index]);
                    }
                }

                if (index >= (SFPGFSupplierFeedbackPartView.GetPageIndex() * SFPGFSupplierFeedbackPartView.cpPageSize) &&
                    index < SFPGFSupplierFeedbackPartView.GetVisibleRowsOnPage() + (SFPGFSupplierFeedbackPartView.GetPageIndex() * SFPGFSupplierFeedbackPartView.cpPageSize)) {
                    selection = selectionList[1].split(',');

                    if (selection[index] != null && selection[index] != '') {
                        radioButtonList = ASPxClientControl.GetControlCollection().GetByName("SFPGFGRPN_1_REPLY" + index);
                        radioButtonList.SetSelectedIndex(selection[index]);
                    }
                }

                if (index >= (SFPGFSupplierFeedbackPartView.GetPageIndex() * SFPGFSupplierFeedbackPartView.cpPageSize) &&
                    index < SFPGFSupplierFeedbackPartView.GetVisibleRowsOnPage() + (SFPGFSupplierFeedbackPartView.GetPageIndex() * SFPGFSupplierFeedbackPartView.cpPageSize)) {
                    selection = selectionList[2].split(',');

                    if (selection[index] != null && selection[index] != '') {
                        radioButtonList = ASPxClientControl.GetControlCollection().GetByName("SFPGFGRPN_2_REPLY" + index);
                        radioButtonList.SetSelectedIndex(selection[index]);
                    }
                }

                if (index >= (SFPGFSupplierFeedbackPartView.GetPageIndex() * SFPGFSupplierFeedbackPartView.cpPageSize) &&
                    index < SFPGFSupplierFeedbackPartView.GetVisibleRowsOnPage() + (SFPGFSupplierFeedbackPartView.GetPageIndex() * SFPGFSupplierFeedbackPartView.cpPageSize)) {
                    selection = selectionList[3].split(',');

                    if (selection[index] != null && selection[index] != '') {
                        radioButtonList = ASPxClientControl.GetControlCollection().GetByName("SFPGFGRPN_3_REPLY" + index);
                        radioButtonList.SetSelectedIndex(selection[index]);
                    }
                }
            }
        }
    }

    // handle row seleciton with reply radio button.

    function OnSFPGFGRPREPLYSelectedIndexChanged(fieldIndex, fieldName, fieldValue) {
        // get previous stored radio button list sellection list.
        var previousSelectionList = [];
        previousSelectionList = SFPGFSupplierFeedbackPartViewSelectionLabel.GetValue().split(';');
        if (previousSelectionList[0] != null && previousSelectionList[0] != '')
            SFPGFSupplierFeedbackPartView.cpNReply = previousSelectionList[0].split(',');
        if (previousSelectionList[1] != null && previousSelectionList[1] != '')
            SFPGFSupplierFeedbackPartView.cpN1Reply = previousSelectionList[1].split(',');
        if (previousSelectionList[2] != null && previousSelectionList[2] != '')
            SFPGFSupplierFeedbackPartView.cpN2Reply = previousSelectionList[2].split(',');
        if (previousSelectionList[3] != null && previousSelectionList[3] != '')
            SFPGFSupplierFeedbackPartView.cpN3Reply = previousSelectionList[3].split(',');

        switch (fieldName) {
            case 'N_MONTH':
                SFPGFSupplierFeedbackPartView.cpNReply[fieldIndex] = fieldValue;
                break;
            case 'N_1_MONTH':
                SFPGFSupplierFeedbackPartView.cpN1Reply[fieldIndex] = fieldValue;
                break;
            case 'N_2_MONTH':
                SFPGFSupplierFeedbackPartView.cpN2Reply[fieldIndex] = fieldValue;
                break;
            case 'N_3_MONTH':
                SFPGFSupplierFeedbackPartView.cpN3Reply[fieldIndex] = fieldValue;
                break;
        }

        var selectionList = [];
        selectionList[0] = SFPGFSupplierFeedbackPartView.cpNReply.join(',');
        selectionList[1] = SFPGFSupplierFeedbackPartView.cpN1Reply.join(',');
        selectionList[2] = SFPGFSupplierFeedbackPartView.cpN2Reply.join(',');
        selectionList[3] = SFPGFSupplierFeedbackPartView.cpN3Reply.join(',');

        SFPGFSupplierFeedbackPartViewSelectionLabel.SetValue(selectionList.join(';'));
    }

    function OnSFPGFGRPN_REPLYSelectedIndexChanged(s, e) {
        var index = s.name.substring(15);
        var radioButtonList = ASPxClientControl.GetControlCollection().GetByName(s.name);
        OnSFPGFGRPREPLYSelectedIndexChanged(index, 'N_MONTH', radioButtonList.GetSelectedIndex());
    }

    function OnSFPGFGRPN_1_REPLYSelectedIndexChanged(s, e) {
        var index = s.name.substring(17);
        var radioButtonList = ASPxClientControl.GetControlCollection().GetByName(s.name);
        OnSFPGFGRPREPLYSelectedIndexChanged(index, 'N_1_MONTH', radioButtonList.GetSelectedIndex());
    }

    function OnSFPGFGRPN_2_REPLYSelectedIndexChanged(s, e) {
        var index = s.name.substring(17);
        var radioButtonList = ASPxClientControl.GetControlCollection().GetByName(s.name);
        OnSFPGFGRPREPLYSelectedIndexChanged(index, 'N_2_MONTH', radioButtonList.GetSelectedIndex());
    }

    function OnSFPGFGRPN_3_REPLYSelectedIndexChanged(s, e) {
        var index = s.name.substring(17);
        var radioButtonList = ASPxClientControl.GetControlCollection().GetByName(s.name);
        OnSFPGFGRPREPLYSelectedIndexChanged(index, 'N_3_MONTH', radioButtonList.GetSelectedIndex());
    }

    function OnSFPGFSupplierFeedbackPartViewEndCallback(s, e) {
        OnSFPGFSupplierFeedbackPartViewUpdateRow();
    }

    function OnSFPGFSupplierFeedbackPartViewBeginCallback(s, e) {
        e.customArgs["ProductionMonth"] = productionMonth;
        e.customArgs["SupplierCode"] = supplierCode;
        e.customArgs["SupplierPlanCode"] = supplierPlantCode;
        e.customArgs["Version"] = version;

        e.customArgs["FilePath"] = filePath;

        filePath = "";
    }

    function OnFDLPOPTFeedbackReplyLinkClick(s, e) {
        var index = s.name.substring(25);

        productionMonth = ForecastDetailView.cpProductionMonth[index];
        supplierCode = ForecastDetailView.cpSupplierCd[index];
        supplierPlanCode = ForecastDetailView.cpSupplierPlant[index];
        version = 'T';

        popupFeedbackPart.Show();
    }

    function OnFDLPOPFFeedbackReplyLinkClick(s, e) {
        var index = s.name.substring(25);

        productionMonth = ForecastDetailView.cpProductionMonth[index];
        supplierCode = ForecastDetailView.cpSupplierCd[index];
        supplierPlanCode = ForecastDetailView.cpSupplierPlant[index];
        version = 'F';

        popupFeedbackPart.Show();
    }

    function OnPopupFeedbackPartShown(s, e) {
        popupFeedbackPart.SetHeaderText("Monthly Forecast : " + GetRegularProductionMonth(productionMonth));
        popupFeedbackPart.PerformCallback();
    }

    function OnSFPFFFileUploadFileUploadComplete(s, e) {
        if (e.isValid) {
            filePath = e.callbackData;

            $.ajax({
                type: "POST",
                url: "/SupplierFeedbackPart/PartialGridSupplierFeedbackPartForecast_Upload",
                dataType: "json",
                data: {
                    partNo: partNo
                    , productionMonth: productionMonth
                    , supplierCode: supplierCode
                    , supplierPlanCode: supplierPlanCode
                    , version: version
                    , filePath: filePath
                },
                success: function (result) {
                    $("#SupplierFeedbackPartGridPartial_Forecast").html(result.View);

                    var parameterValues = result.Status.split(';');
                    if (parameterValues[0] == "true") {
                        // clear temporary upload data
                        OnSFPFFFileUploadFileUploadCleared(parameterValues[1], parameterValues[2], parameterValues[3], parameterValues[4]);
                        OnSFPGFUCOkButtonClick();
                    }
                    else if (parameterValues[0] == "false") {
                        OnSFPFFFileUploadFileUploadInvalid(parameterValues[1], parameterValues[2], parameterValues[3], parameterValues[4]);
                    }
                },
                error: function (result) {
                    alert("Error On SFPFFFileUpload File Upload Complete.");
                }
            });
        }
    }

    function OnSFPFFFileUploadFileUploadInvalid(processId, functionId, temporaryTableUpload, temporaryTableValidate) {
        $.fileDownload("SupplierFeedbackPart/DownloadInvalid/", {
            data: {
                partNo: partNo,
                productionMonth: productionMonth,
                supplierCode: supplierCode,
                supplierPlanCode: supplierPlanCode,
                version: version,
                processId: processId,
                functionId: functionId
            },
            successCallback: function (url) {
                // clear temporary upload data
                OnSFPFFFileUploadFileUploadCleared(processId, functionId, temporaryTableUpload, temporaryTableValidate);
            },
            failCallback: function (responseHtml, url) {
                alert("Error On SFPFFFileUpload File Upload Invalid.");
            }
        });
    }

    function OnSFPFFFileUploadFileUploadCleared(processId, functionId, temporaryTableUpload, temporaryTableValidate) {
        $.ajax({
            type: "POST",
            url: "/SupplierFeedbackPart/ClearAllFeedbackPartUpload",
            data: {
                processId: processId,
                functionId: functionId,
                temporaryTableUpload: temporaryTableUpload,
                temporaryTableValidate: temporaryTableValidate
            },
            success: function (result) {

            },
            error: function (result) {
                alert("Error On SFPFFFileUpload File Upload Cleared.");
            }
        });
    }

    function OnSFPFFUploadButtonClick(s, e) {
        popupFeedbackPartGridUploadConfirmation.Show();
    }

    function OnSFPRHFOkButtonClick(s, e) {
        OnFFPConfirmButtonClick();
    }

    function OnFFPConfirmButtonClick(s, e) {
        popupFeedbackPartGridUpdateConfirmation.Show();
    }

    function OnSFPGFUCOkButtonClick(s, e) {
        var parameterList = "";
        var isValid = true;

        // get previous stored radio button list sellection list.
        var previousSelectionList = [];
        previousSelectionList = SFPGFSupplierFeedbackPartViewSelectionLabel.GetValue().split(';');
        if (previousSelectionList[0] != null && previousSelectionList[0] != '')
            SFPGFSupplierFeedbackPartView.cpNReply = previousSelectionList[0].split(',');
        if (previousSelectionList[1] != null && previousSelectionList[1] != '')
            SFPGFSupplierFeedbackPartView.cpN1Reply = previousSelectionList[1].split(',');
        if (previousSelectionList[2] != null && previousSelectionList[2] != '')
            SFPGFSupplierFeedbackPartView.cpN2Reply = previousSelectionList[2].split(',');
        if (previousSelectionList[3] != null && previousSelectionList[3] != '')
            SFPGFSupplierFeedbackPartView.cpN3Reply = previousSelectionList[3].split(',');

        for (var index = SFPGFSupplierFeedbackPartView.cpStartIndex; index < SFPGFSupplierFeedbackPartView.cpEndIndex; index++) {
            parameterList += SFPGFSupplierFeedbackPartView.cpPartNo[index] + "|";
            parameterList += SFPGFSupplierFeedbackPartView.cpPackMonth[index] + "|";
            parameterList += SFPGFSupplierFeedbackPartView.cpSupplierCd[index] + "|";
            parameterList += SFPGFSupplierFeedbackPartView.cpSPlantCd[index] + "|";
            parameterList += SFPGFSupplierFeedbackPartView.cpVers[index] + "|";
            parameterList += SFPGFSupplierFeedbackPartView.cpDockCd[index] + "|";

            parameterList += SFPGFSupplierFeedbackPartView.cpNVolume[index] + "|";
            parameterList += SFPGFSupplierFeedbackPartView.cpN1Volume[index] + "|";
            parameterList += SFPGFSupplierFeedbackPartView.cpN2Volume[index] + "|";
            parameterList += SFPGFSupplierFeedbackPartView.cpN3Volume[index] + "|";

            parameterList += SFPGFSupplierFeedbackPartView.cpNFA[index] + "|";
            parameterList += SFPGFSupplierFeedbackPartView.cpN1FA[index] + "|";
            parameterList += SFPGFSupplierFeedbackPartView.cpN2FA[index] + "|";
            parameterList += SFPGFSupplierFeedbackPartView.cpN3FA[index] + "|";

            // check if all input is complete
            if (
                SFPGFSupplierFeedbackPartView.cpNReply[index] == -1 || SFPGFSupplierFeedbackPartView.cpNReply[index] == null || SFPGFSupplierFeedbackPartView.cpNReply[index] == "" ||
                SFPGFSupplierFeedbackPartView.cpN1Reply[index] == -1 || SFPGFSupplierFeedbackPartView.cpN1Reply[index] == null || SFPGFSupplierFeedbackPartView.cpN1Reply[index] == "" ||
                SFPGFSupplierFeedbackPartView.cpN2Reply[index] == -1 || SFPGFSupplierFeedbackPartView.cpN2Reply[index] == null || SFPGFSupplierFeedbackPartView.cpN2Reply[index] == "" ||
                SFPGFSupplierFeedbackPartView.cpN3Reply[index] == -1 || SFPGFSupplierFeedbackPartView.cpN3Reply[index] == null || SFPGFSupplierFeedbackPartView.cpN3Reply[index] == ""
                )
                isValid = false;

            parameterList += SFPGFSupplierFeedbackPartView.cpNReply[index] + "|";
            parameterList += SFPGFSupplierFeedbackPartView.cpN1Reply[index] + "|";
            parameterList += SFPGFSupplierFeedbackPartView.cpN2Reply[index] + "|";
            parameterList += SFPGFSupplierFeedbackPartView.cpN3Reply[index] + "|";

            parameterList += SFPGFSupplierFeedbackPartView.cpNotice[index] + "|";
            parameterList += SFPGFSupplierFeedbackPartView.cpDID[index] + "|";
            parameterList += SFPGFSupplierFeedbackPartView.cpCarCd[index];
            parameterList += ";"
        }
        if (parameterList.length > 0)
            parameterList = parameterList.substring(0, parameterList.length - 1);

        if (isValid) {
            $.ajax({
                type: "POST",
                url: "/SupplierFeedbackPart/UpdateFeedbackPart",
                data: {
                    parameterList: parameterList
                },
                success: function (result) {
                    popupFeedbackPartGridUpdateConfirmation.Hide();
                    popupFeedbackPart.PerformCallback();
                },
                error: function (result) {
                    alert("Error On FFPConfirmButton Click.");
                }
            });
        }
        else {
            alert("Update Supplier Feedback Part Data is invalid.\nAll input value has to be entered.\nPlease input again!");
            popupFeedbackPartGridUpdateConfirmation.Hide();
        }
    }

    function OnSFPFFDownloadTemplateLinkClick(s, e) {
        $.fileDownload("SupplierFeedbackPart/DownloadTemplate/", {
            data: {
                partNo: partNo,
                productionMonth: productionMonth,
                supplierCode: supplierCode,
                supplierPlanCode: supplierPlanCode,
                version: version
            },
            successCallback: function (url) {
                alert(url);
            },
            failCallback: function (responseHtml, url) {
                alert(responseHtml);
            }
        });
    }

    function OnPopupFeedbackPartGridUpdateConfirmationShown(s, e) {

    }

    function OnSFPGFUCCancelButtonClick(s, e) {
        popupFeedbackPartGridUpdateConfirmation.Hide();
    }

    function OnSFPGFUPCOkButtonClick(s, e) {
        popupFeedbackPartGridUploadConfirmation.Hide();
        SFPFFFileUpload.UploadFile();
    }

    function OnPopupFeedbackPartGridUploadConfirmationShown(s, e) {

    }

    function OnSFPGFUPCCancelButtonClick(s, e) {
        popupFeedbackPartGridUploadConfirmation.Hide();
    }
    // =============================================================================
</script>

<link href="@Url.Content("~/Content/Style/SupplierFeedbackSum.css")" rel="stylesheet" type="text/css"/>

<div style="display:table;border:1px solid #142B94; background-color:#DEECFD; padding:10px;">
    @Html.Action("PartialHeaderSupplierFeedbackSummary", "SupplierFeedbackSummary")
</div>        
<div style="height: 15px;"></div> @* div spacing *@
<div> 
    @Html.Action("PartialDetailSupplierFeedbackSummary", "SupplierFeedbackSummary")
</div>
<div style="height: 100px;">
</div>
@Html.DevExpress().PopupControl(settings =>
{
    settings.Name = "popupFeedbackPart";
    settings.HeaderText = "Monthly Forecast : ";
    settings.CallbackRouteValues = new { Controller = "SupplierFeedbackSummary", Action = "PartialPopupForecastFeedbackPart" };
    settings.Width = System.Web.UI.WebControls.Unit.Percentage(100);
    settings.Height = System.Web.UI.WebControls.Unit.Pixel(550);
    settings.ScrollBars = ScrollBars.Auto;
    settings.PopupHorizontalAlign = PopupHorizontalAlign.WindowCenter;
    settings.PopupVerticalAlign = PopupVerticalAlign.WindowCenter;
    settings.Modal = true;
    settings.ShowPageScrollbarWhenModal = true;
    settings.ClientSideEvents.Shown = "OnPopupFeedbackPartShown";
    settings.ClientSideEvents.Closing = "OnPopupFeedbackClosing";
    settings.ClientSideEvents.BeginCallback = "OnPopupFeedbackBeginCallback";
    settings.SetContent(() =>
    {
        Html.RenderAction("PartialEmptyPopupForecastFeedbackPart", "Forecast");
    });
}).GetHtml()
@Html.DevExpress().PopupControl(settings =>
{
    settings.Name = "popupSupplierFeedbackSummaryDetailUnlockConfirmation";
    settings.HeaderText = "Supplier Feedback Summary Unlock Confirmation";
    settings.Width = System.Web.UI.WebControls.Unit.Pixel(320);
    settings.Height = System.Web.UI.WebControls.Unit.Pixel(250);
    settings.ScrollBars = ScrollBars.Auto;
    settings.PopupHorizontalAlign = PopupHorizontalAlign.WindowCenter;
    settings.PopupVerticalAlign = PopupVerticalAlign.WindowCenter;
    settings.Modal = true;
    settings.ShowPageScrollbarWhenModal = true;
    settings.ClientSideEvents.Shown = "OnPopupSupplierFeedbackSummaryDetailUnlockConfirmationShown";
    settings.ClientSideEvents.Closing = "OnPopupFeedbackClosing";
    settings.SetContent(() =>
    {
        Html.RenderPartial("SupplierFeedbackSummaryDetailUnlockConfirmationPartial", Model);
    });
}).GetHtml()
@Html.DevExpress().PopupControl(settings =>
{
    settings.Name = "popupFeedbackPartGridUpdateConfirmation";
    settings.HeaderText = "Suplier Feedback Part Update Confirmation";
    settings.Width = System.Web.UI.WebControls.Unit.Pixel(300);
    settings.ScrollBars = ScrollBars.Auto;
    settings.PopupHorizontalAlign = PopupHorizontalAlign.WindowCenter;
    settings.PopupVerticalAlign = PopupVerticalAlign.WindowCenter;
    settings.Modal = true;
    settings.ShowPageScrollbarWhenModal = true;
    settings.ClientSideEvents.Shown = "OnPopupFeedbackPartGridUpdateConfirmationShown";
    settings.SetContent(() =>
    {
        Html.RenderPartial("~/Views/SupplierFeedbackPart/SupplierFeedbackPartGridUpdateConfirmationPartial_Forecast.cshtml", Model);
    });
}).GetHtml()
@Html.DevExpress().PopupControl(settings =>
{
    settings.Name = "popupFeedbackPartGridUploadConfirmation";
    settings.HeaderText = "Suplier Feedback Part Upload Confirmation";
    settings.Width = System.Web.UI.WebControls.Unit.Pixel(300);
    settings.ScrollBars = ScrollBars.Auto;
    settings.PopupHorizontalAlign = PopupHorizontalAlign.WindowCenter;
    settings.PopupVerticalAlign = PopupVerticalAlign.WindowCenter;
    settings.Modal = true;
    settings.ShowPageScrollbarWhenModal = true;
    settings.ClientSideEvents.Shown = "OnPopupFeedbackPartGridUploadConfirmationShown";
    settings.SetContent(() =>
    {
        Html.RenderPartial("~/Views/SupplierFeedbackPart/SupplierFeedbackPartGridUploadConfirmationPartial_Forecast.cshtml", Model);
    });
}).GetHtml()
@Html.Common().DevExpress().MessageBoard(settings =>
    {
        settings.Name = "MessageBoard";
        settings.BoardName = "Supplier Feedback Summary";
        settings.Position = MessageBoardPosition.RIGHT;
    }).GetHtml()